package cn.fw.dalaran.domain.vo;

import cn.fw.dalaran.domain.enums.SubTypeEnum;
import cn.fw.dalaran.domain.param.EvlParams;
import lombok.Data;
import lombok.ToString;
import org.springframework.beans.BeanUtils;

import java.math.BigDecimal;
import java.util.Objects;

/**
 * @author kurisu
 * @date 2021-11-18 11:07
 * @description 评价子指标
 */
@Data
@ToString
public class EvlSubIndexVO {
    /**
     * 主键id
     */
    private Long id;
    /**
     * 父指标id
     */
    private Long evlId;
    /**
     * 子指标类型
     */
    private SubTypeEnum subType;
    /**
     * 占比 （%）
     */
    private BigDecimal rate;

    /**
     * 获取
     * @return
     */
    public String getSubTypeDesc() {
        if (Objects.nonNull(this.getSubType()))
            return subType.getName();
        return null;
    }

    public static EvlParams.EvlIndex toIndex(EvlSubIndexVO vo) {
        final EvlParams.EvlIndex db = new EvlParams.EvlIndex();
        BeanUtils.copyProperties(vo, db);
        return db;
    }
}
